module SQD (
    clk,
    rst,
    in_data,
    out_data,
);

    input clk,rst,in_data;
    output out_data;

    reg out_data;

    reg [1:0]state,next_state;
    
    localparam S0 = 2'd0;
    localparam S1 = 2'd1;
    localparam S2 = 2'd2;
    localparam S3 = 2'd3;

always @(posedge clk,posedge rst) begin
    if(rst)
        state <= S0;
    else
        state <= next_state;
end

always @(*) begin
    case (state)
        S0: next_state = (in_data)? S1 : S0;
        S1: next_state = (in_data)? S1 : S2;
        S2: next_state = (in_data)? S3 : S0;
        S3: next_state = (in_data)? S1 : S2;
    endcase
end

always @(*) begin
    case (state)
        S0: out_data = 1'b0;
        S1: out_data = 1'b0;
        S2: out_data = 1'b0;
        S3: out_data = 1'b1;
    endcase
end
    
endmodule